<?php
/*
Plugin Name: YouTube SimpleGallery
Plugin URI: http://www.stianandreassen.com/plugins/youtube-simplegallery/
Description: A YouTube Gallery Plugin, that let's you add a gallery of videos to any Page or Post. Use [youtubegallery]{youtube-links}[/youtubegallery], with a list of YouTube-links separated with linebreaks to add a gallery.
Author: Stian Andreassen
Author URI: http://www.stianandreassen.com
Version: 0.1 BETA
*/

add_action('wp_head', 'youtube_gallery_css');

// ADD OPTIONS PAGE
add_action('admin_menu', 'youtubegallery_admin');
function youtubegallery_admin() {
  add_options_page('YouTube Gallery', 'YouTube Gallery', '9', 'youtube-gallery', 'youtubegallery_options');
  
  if($_REQUEST['action'] == 'update_youtube_gallery'){
  	delete_option('youtube_gallery_option');
	add_option('youtube_gallery_option', array('width' => $_REQUEST['youtubegallery_width'], 'height' => $_REQUEST['youtubegallery_height'], 'thickbox' => $_REQUEST['youtubegallery_thickbox'], 'css' => $_REQUEST['youtubegallery_css']));
  }
}

// SHOW OPTIONS
function youtubegallery_options(){
?>
<style type="text/css">
<!--
	#plugins td, #plugins th {
		border-bottom: none;
		padding: 10px;
	}
	
	#plugins th {
		text-align: right;
	}
-->
</style>
<div id="wpbody-content">
	<div class="wrap">
		<div id="icon-options-general" class="icon32"><br /></div>
		<h2>YouTube Gallery Settings</h2>
		<br />
		<?php
	    if ( $_REQUEST['update'] ) echo '<div id="message" class="updated fade"><p><strong>Settings saved.</strong></p></div>';
		$youtube_gallery_options = get_option('youtube_gallery_option');
		?>

		<form method="POST">
		<table class="widefat" id="plugins" style="width: 400px;">
			<tbody>
				<tr>
					<th scope="row">Width:</th><td><input type="text" name="youtubegallery_width" size="6" value="<?php echo $youtube_gallery_options['width'] ?>"> <span style="color: #999;">Width of embedded video</span></td>
				</tr>
				<tr>
					<th scope="row">Height:</th><td><input type="text" name="youtubegallery_height" size="6" value="<?php echo $youtube_gallery_options['height'] ?>"> <span style="color: #999;">Height of embedded video</span></td>
				</tr>
				<tr>
					<th scope="row">Use&nbsp;Thickbox:</th><td><input type="checkbox" name="youtubegallery_thickbox" value="thickbox"<?php if($youtube_gallery_options['thickbox'] == 'thickbox') echo' checked'; ?>> <span style="color: #999;">Opens videos in a box on your page &ndash; requires the <a href="http://wordpress.org/extend/plugins/thickbox/">Thickbox Plugin</a><br /><b>Disable if you want the links to go directly to the YouTube-page</b></span></td>
				</tr>
				<tr>
					<th scope="row">Use&nbsp;CSS:</th><td><input type="checkbox" name="youtubegallery_css" value="usecss"<?php if($youtube_gallery_options['css'] == 'usecss') echo' checked'; ?>> <span style="color: #999;">Use CSS included with plugin<br /><b>Disable if you want to use your own CSS</b></span></td>
				</tr>
			</tbody>
		</table>
		<p class="submit">
		<input name="update" type="submit" value="<?php _e('Update Settings'); ?>" />
		<input type="hidden" name="action" value="update_youtube_gallery" />
		</p>
		</form>

<h3>Thickbox status:</h3>		
<p>
<?php 
if(function_exists('is_thickbox_enabled'))
echo 'Thickbox is installed and activated';
else
echo 'Thickbox is NOT installed and/or not actived.
Please download <a href="http://wordpress.org/extend/plugins/thickbox/">Thickbox</a>, install and activate it if you want to use it with this plugin.'; 
?>
</p>
	</div>
</div>
<?php
}


// OUTPUT THE GALLERY
function show_youtubegallery( $atts, $youtubelinks = null ) {
$youtubelinks = explode("\n", $youtubelinks);
$youtubeoptions = get_option('youtube_gallery_option');
$x = 0;
$showgallery = ('<div class="youtube_gallery"><p>');
	foreach ( $youtubelinks as $thumbnails ):
		if(strstr($thumbnails, 'http://www.youtube.com/watch?v=')){
		$x++;
		$thumb = $thumbnails;
		if(strstr($thumb, '&')) $thumb = substr($thumb, 0, strpos($thumb, '&'));
		$thumb = str_replace('http://www.youtube.com/watch?v=', '', $thumb);
		$thumb = str_replace('<br />', '', $thumb);
		if($youtubeoptions['thickbox'] == 'thickbox') {
			$showgallery .= '<span id="youtube_gallery_item_'.$x.'" class="youtube_gallery_item"><a href="#TB_inline?height='.($youtubeoptions['height']+30).'&width='.($youtubeoptions['width']+10).'&inlineId=youtubeplayer-'.$x.'" class="thickbox"><img src="http://img.youtube.com/vi/'.str_replace("\r", '', $thumb).'/default.jpg" border="0"></a></span>'."\r";
			}
		else {
			$showgallery .= '<span id="youtube_gallery_item_'.$x.'" class="youtube_gallery_item"><a href="'.str_replace('<br />', '', $thumbnails).'"><img src="http://img.youtube.com/vi/'.str_replace("\r", '', $thumb).'/default.jpg" border="0"></a></span>'."\r";
			}
		}
	endforeach;
	$showgallery .= ('</p></div>');

if($youtubeoptions['thickbox'] == 'thickbox'):	
	$x = 0;
	foreach ( $youtubelinks as $video ):
		if(strstr($video, '&')) $video = substr($video, 0, strpos($video, '&'));
		if(strstr($video, 'http://www.youtube.com/watch?v=')){
		$x++;
		$video = str_replace('watch?v=', 'v/', $video);
		$video = str_replace('<br />', '', $video);
		$showgallery .= '
		<div id="youtubeplayer-'.$x.'" style="display: none; text-align: center;"><br />
		<object width="'.$youtubeoptions['width'].'" height="'.$youtubeoptions['height'].'">
			<param name="movie" value="'.str_replace("\r", '', $video).'&amp;hl=en_US&amp;fs=1&amp;"></param>
			<param name="allowFullScreen" value="true"></param>
			<param name="allowscriptaccess" value="always"></param>
			<embed src="'.str_replace("\r", '', $video).'&amp;hl=en_US&amp;fs=1&amp;" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$youtubeoptions['width'].'" height="'.$youtubeoptions['height'].'"></embed>
		</object>
		</div>
		';
		}
	endforeach;
endif;
return $showgallery;
}
add_shortcode('youtubegallery', 'show_youtubegallery');

// ON INSTALL PLUGIN
function youtubegallery_install(){
		add_option('youtube_gallery_option', array('width' => '560', 'height' => '340', 'thickbox' => 'thickbox', 'css' => 'usecss'));

}

// ON UNINSTALL PLUGIN
function youtubegallery_uninstall(){
		delete_option('youtube_gallery_option');

}

function youtube_gallery_css(){
$youtubeoptions = get_option('youtube_gallery_option');
if($youtubeoptions['css'] == 'usecss')
	echo('<link rel="stylesheet" href="'.get_bloginfo('home').'/wp-content/plugins/youtube-simplegallery/youtube_simplegallery.css" type="text/css" media="screen" />
');
}

register_activation_hook(__FILE__,'youtubegallery_install');	
register_deactivation_hook(__FILE__,'youtubegallery_uninstall');	


?>
